<?php
/**
 * Plugin Name: HM visual editor shortcodes
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: hamrah mechanic visual editor shortcodes
 * Version:     4.1.7
 * Author:      Mahdi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: hm-ve-shortcodes
 * Domain Path: /languages
 * 
 */
 
 
  
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

define("hmves_url", plugin_dir_url(__FILE__));


function hmves_load_textdomain() {
  load_plugin_textdomain( 'hm-ve-shortcodes', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
} 
add_action( 'plugins_loaded', 'hmves_load_textdomain' );





if ( ! class_exists( 'hm_visual_editor_shortcodes' ) ) {
	class hm_visual_editor_shortcodes {
		private static $settings;
		private function __construct() {
		} 
		public static function init_actions() {
			$plugin_data = get_file_data(__FILE__, [
				'Version' => 'Version',
				'TextDomain' => 'hm-ve-shortcodes'
			], 'plugin');
			//$hm_visual_editor_shortcodes_plugin_data = get_plugin_data( __FILE__ );
			define("hm_visual_editor_shortcodes_version",$plugin_data['Version']); 
			
			register_activation_hook( __FILE__, array( __CLASS__, 'activate' ) );
			register_deactivation_hook(__FILE__, array( __CLASS__, 'deactivat'));
			register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
			add_action('before_wp_tiny_mce',  array( __CLASS__, 'hmves_add_inline_css_to_footer_admin_area'));
			add_action('admin_head',  array( __CLASS__, 'custom_mce_button'));
			add_shortcode('hm_shortcode', array( __CLASS__ , 'echo_shortcode'));
			add_action( 'admin_menu', array( __CLASS__ , 'add_admin_menu' ) );
			add_action( 'admin_init', array( __CLASS__ , 'settings_init' ) );
			add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( __CLASS__, 'add_settings_link' ), 10, 2 );
			add_action( 'admin_enqueue_scripts', array( __CLASS__, 'enqueue_backend' ) );
			add_action( 'wp_enqueue_scripts', array( __CLASS__, 'enqueue_front' ) );
			add_action( 'wp_ajax_hm_visual_editor_shortcodes_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'wp_ajax_nopriv_hm_visual_editor_shortcodes_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'rest_api_init', array( __CLASS__,'register_route') );
			$settings = self::get_settings();
			//if ( $settings['xxx'] ) {
			//} else {
			//}
		} 
		public static function custom_mce_button() {
		  // Check if user have permission
		  if ( !current_user_can( 'edit_pages' ) ) {
			return;
		  }
		  // Check if WYSIWYG is enabled
		  if ( 'true' == get_user_option( 'rich_editing' ) ) {
			add_filter( 'mce_external_plugins', array( __CLASS__,'custom_tinymce_plugin') );
			add_filter( 'mce_buttons', array( __CLASS__,'register_mce_button') );
		  }
		}
		// Function for new button
		public static function custom_tinymce_plugin( $plugin_array ) {
		  $plugin_array['custom_mce_button'] = plugin_dir_url( __FILE__ ) . 'assets/back.js';
		  return $plugin_array;
		}


		// Register new button in the editor
		public static function register_mce_button( $buttons ) {
		  array_push( $buttons, 'custom_mce_button' );
		  return $buttons;
		}
		public static function hmves_add_inline_css_to_footer_admin_area(){ 
			$settings =  self::get_settings();
			//hm_install_app_text
			?>
				<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
				<script src="//code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
				<script type="text/javascript">
				//alert('ddddddd');
				var hm_miss_link_1_text = <?php echo '"'. $settings['hm_miss_link_1_text'].'"' ?>;
				var hm_miss_link_1_url = <?php echo '"'. $settings['hm_miss_link_1_url'].'"' ?>;
				var hm_miss_link_2_text = <?php echo '"'. $settings['hm_miss_link_2_text'].'"' ?>;
				var hm_miss_link_2_url = <?php echo '"'. $settings['hm_miss_link_2_url'].'"' ?>;
				var hm_miss_link_3_text = <?php echo '"'. $settings['hm_miss_link_3_text'].'"' ?>;
				var hm_miss_link_3_url = <?php echo '"'. $settings['hm_miss_link_3_url'].'"' ?>;
				
				</script>
				<script>
					<?php 
						$admin_ajax_url =  admin_url( 'admin-ajax.php' );
						echo "hmves_admin_ajax_url = '".$admin_ajax_url."';";
						echo "hmves_this_site_url  = '".get_site_url()."';";//http://www.example.com
						//ایجاد کوکی برای ویریفای شخص حاضر در جاوا اسکریپت
						$hmves_authentication = array('nonce' => wp_create_nonce('wp_rest'));
						?>var hmves_authentication = <?php echo json_encode($hmves_authentication) ?>;<?php
					?>
				</script>
				<style>
				.mce-i-custom-mce-icon {
				  background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/logo.png' ?>");

				}
				.mce-i-custom-mce-icon-install-app {
					background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/install_app.png' ?>");
					background-size: auto 100%;
					background-repeat: no-repeat;
				}
				.mce-i-custom-mce-icon-sell {
					background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/sell.png' ?>");
					background-size: auto 100%;
					background-repeat: no-repeat;
				}
				.mce-i-custom-mce-icon-buy {
					background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/buy.png' ?>");
					background-size: auto 100%;
					background-repeat: no-repeat;
				}
				.mce-i-custom-mce-icon-exhibition {
					background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/exhibition.png' ?>");
					background-size: auto 100%;
					background-repeat: no-repeat;
				}
				
				.mce-i-custom-mce-icon-miss {
					background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/miss.png' ?>");
					background-size: auto 100%;
					background-repeat: no-repeat;
				}
				.mce-i-custom-mce-icon-buy-url {
					background-image: url("<?php echo plugin_dir_url( __FILE__ ) . 'assets/buy.png' ?>");
					background-size: auto 100%;
					background-repeat: no-repeat;
				}
				/* زد ایندکس آتو کمپلت توی دیالوگ ویرایشگر بالا نماید ، افزایشش میدیم */
				ul.ui-menu.ui-widget.ui-widget-content.ui-autocomplete.ui-front {
					z-index: 9999999999;
				}
				</style>
				
				
			<?php }
		public static function handel_ajax(){
			if(isset($_POST) and isset($_POST['action']) and $_POST['action']=='hm_visual_editor_shortcodes_ajax' ){
				$results = get_posts(array(
				   'post_type' => 'hmves_car_buy_url',
				   'numberposts'=> '10',
				   's' =>  $_POST['term'],
				   //'s' =>  urldecode ($_POST['term']),
				   //'s' => 'پژو'  
				));
				$records = array();
				if(!empty($results)){
					foreach($results as $index => $p_obj){
						$obj = new stdClass();
						$obj->id = $p_obj->ID;
						$obj->value = get_post_meta( $p_obj->ID, 'hmves_record_name', true );
						//$obj->url = get_post_meta( $p_obj->ID, 'hmves_record_url', true );
						$records[] = $obj;
					}
				}
				
			}
			
			//return rest_ensure_response( $records );
			echo json_encode($records);
			//echo $_GET['term'];
			//echo json_encode($records);
			//var_dump($_REQUEST)
			//die($records);
		}
		public static function ajax_request() {
			self::handel_ajax();
			die();
		}
		public static function add_admin_menu(  ) { 
			add_menu_page(
				__( 'hm visual editor shortcodes', 'hm-ve-shortcodes' ),
				__( 'شرت کات ها', 'hm-ve-shortcodes' ),
				'manage_options',
				'hm_visual_editor_shortcodes',
				array(__CLASS__,'hm_visual_editor_shortcodes_options_page'),
				'dashicons-editor-code'
			);
			
			add_submenu_page(
				'hm_visual_editor_shortcodes',
				__( 'خودرو و آدرس', 'hm-ve-shortcodes' ),
				__( 'خودرو و آدرس', 'hm-ve-shortcodes' ),
				'manage_options',
				'books-shortcode-ref',
				array(__CLASS__,'hm_visual_editor_shortcodes_car_urls_submenu'),
			);
		}
		public static function settings_init(  ) { 
			register_setting( 'hm_settings_register', 'hm_ve_settings' );
			
			
			
			//نصب اپ
			
			add_settings_section(
				'hm_settings_section_install_app', 
				__( 'نصب اپ', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_settings_section_callback'), 
				'hm_settings_register'
			);
			add_settings_field( 
				'hm_install_app_text', 
				__( 'متن نصب اپ', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_install_app_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_install_app' 
			);
			add_settings_field( 
				'hm_install_app_url', 
				__( 'آدرس لینک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_install_app_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_install_app' 
			);
			
			
			
			
			
			//فروش
			
			add_settings_section(
				'hm_settings_section_sell', 
				__( 'فروش', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_settings_section_callback_sell'), 
				'hm_settings_register'
			);
			add_settings_field( 
				'hm_sell_before', 
				__( 'متن قبل از لینک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_sell_before_render'), 
				'hm_settings_register', 
				'hm_settings_section_sell' 
			);
			add_settings_field( 
				'hm_sell_link_text', 
				__( 'متن لینک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_sell_link_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_sell' 
			);
			add_settings_field( 
				'hm_sell_link_url', 
				__( 'آدرس لینک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_sell_link_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_sell' 
			);
			add_settings_field( 
				'hm_sell_after', 
				__( 'متن بعد از لینک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_sell_after_render'), 
				'hm_settings_register', 
				'hm_settings_section_sell' 
			);
			
			
			
			
			//خرید
			
			add_settings_section(
				'hm_settings_section_buy', 
				__( 'خرید', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_settings_section_callback_buy'), 
				'hm_settings_register'
			);
			
			
			add_settings_field( 
				'hm_buy_before_link_1', 
				__( 'متن قبل از لینک یک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_before_link_1_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			add_settings_field( 
				'hm_buy_link_1_text', 
				__( 'متن لینک یک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_link_1_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			add_settings_field( 
				'hm_buy_link_1_url', 
				__( 'آدرس لینک یک', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_link_1_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			add_settings_field( 
				'hm_buy_before_link_2', 
				__( 'متن قبل از لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_before_link_2_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			add_settings_field( 
				'hm_buy_link_2_text', 
				__( 'متن لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_link_2_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			add_settings_field( 
				'hm_buy_link_2_url', 
				__( 'آدرس لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_link_2_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			
			add_settings_field( 
				'hm_buy_after_link_2', 
				__( 'متن بعد از لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_buy_after_link_2_render'), 
				'hm_settings_register', 
				'hm_settings_section_buy' 
			);
			
			
			
			
			//نمایشگاه
			add_settings_section(
				'hm_settings_section_exhibition', 
				__( 'نمایشگاه', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_settings_section_callback_exhibition'), 
				'hm_settings_register'
			);
			
			
			add_settings_field( 
				'hm_exhibition_before_link_1', 
				__( 'متن قبل از لینک اول', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_before_link_1_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			add_settings_field( 
				'hm_exhibition_link_1_text', 
				__( 'متن لینک اول', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_link_1_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			add_settings_field(   
				'hm_exhibition_link_1_url', 
				__( 'آدرس لینک اول', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_link_1_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			add_settings_field( 
				'hm_exhibition_before_link_2', 
				__( 'متن قبل از لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_before_link_2_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			add_settings_field( 
				'hm_exhibition_link_2_text', 
				__( 'متن لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_link_2_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			add_settings_field( 
				'hm_exhibition_link_2_url', 
				__( 'آدرس لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_link_2_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			
			add_settings_field( 
				'hm_exhibition_after_link_2', 
				__( 'متن بعد از لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_exhibition_after_link_2_render'), 
				'hm_settings_register', 
				'hm_settings_section_exhibition' 
			);
			
			
			//از دست ندهید
			
			add_settings_section(
				'hm_settings_section_miss', 
				__( 'از دست ندهید', 'hm-ve-shortcodes' ),  
				array( __CLASS__, 'hm_settings_section_callback_miss'), 
				'hm_settings_register'
			); 
			add_settings_field( 
				'hm_miss_link_1_text', 
				__( 'متن لینک اول', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_miss_link_1_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_miss' 
			);
			add_settings_field( 
				'hm_miss_link_1_url', 
				__( 'آدرس لینک اول', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_miss_link_1_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_miss' 
			);
			add_settings_field( 
				'hm_miss_link_2_text', 
				__( 'متن لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_miss_link_2_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_miss' 
			);
			add_settings_field( 
				'hm_miss_link_2_url', 
				__( 'آدرس لینک دوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_miss_link_2_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_miss' 
			);
			add_settings_field( 
				'hm_miss_link_3_text', 
				__( 'متن لینک سوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_miss_link_3_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_miss' 
			);
			add_settings_field( 
				'hm_miss_link_3_url', 
				__( 'آدرس لینک سوم', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_miss_link_3_url_render'), 
				'hm_settings_register', 
				'hm_settings_section_miss' 
			);
			
			
			//خرید خودروی کارشناسی شده
			
			add_settings_section(
				'hm_settings_section_car_link', 
				__( 'خرید خودروی کارشناسی شده', 'hm-ve-shortcodes' ),  
				array( __CLASS__, 'hm_settings_section_callback_car_link'), 
				'hm_settings_register'
			); 
			add_settings_field( 
				'hm_miss_link_1_text', 
				__( 'متن قبل از نام خودرو', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_car_link_start_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_car_link' 
			);
			add_settings_field( 
				'hm_miss_link_1_url', 
				__( 'متن بعد از نام خودرو', 'hm-ve-shortcodes' ), 
				array( __CLASS__, 'hm_car_link_end_text_render'), 
				'hm_settings_register', 
				'hm_settings_section_car_link' 
			);
			
		}
		
		//نصب اپ
		
		public static function hm_install_app_text_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_install_app_text]" class="hm_install_app_text" ><?php echo $options['hm_install_app_text']; ?></textarea>
			<?php
		}
		public static function hm_install_app_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_install_app_url]" class="hm_install_app_url" value="<?php echo $options['hm_install_app_url']; ?>" style="width: 400px;" />
			<?php
		}
		
		
		
		
		//فروش
		
		public static function hm_sell_before_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_sell_before]" class="hm_sell_before" ><?php echo $options['hm_sell_before']; ?></textarea>
			<?php
		}
		public static function hm_sell_link_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_sell_link_text]" class="hm_sell_link_text" value="<?php echo $options['hm_sell_link_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_sell_link_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_sell_link_url]" class="hm_sell_link_url" value="<?php echo $options['hm_sell_link_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_sell_after_render( ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_sell_after]" class="hm_sell_after" ><?php echo $options['hm_sell_after']; ?></textarea>
			<?php
		}
		
		
		
		//خرید
		public static function hm_buy_before_link_1_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_buy_before_link_1]" class="hm_buy_before_link_1" ><?php echo $options['hm_buy_before_link_1']; ?></textarea>
			<?php
		}
		public static function hm_buy_link_1_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_buy_link_1_text]" class="hm_buy_link_1_text" value="<?php echo $options['hm_buy_link_1_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_buy_link_1_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_buy_link_1_url]" class="hm_buy_link_1_url" value="<?php echo $options['hm_buy_link_1_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_buy_before_link_2_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_buy_before_link_2]" class="hm_buy_before_link_2" ><?php echo $options['hm_buy_before_link_2']; ?></textarea>
			<?php
		}
		public static function hm_buy_link_2_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_buy_link_2_text]" class="hm_buy_link_2_text" value="<?php echo $options['hm_buy_link_2_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_buy_link_2_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_buy_link_2_url]" class="hm_buy_link_2_url" value="<?php echo $options['hm_buy_link_2_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_buy_after_link_2_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_buy_after_link_2]" class="hm_buy_after_link_2" ><?php echo $options['hm_buy_after_link_2']; ?></textarea>
			<?php
		}
		
		
		
		
		
		//نمایشگاه
		
		
		public static function hm_exhibition_before_link_1_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_exhibition_before_link_1]" class="hm_exhibition_before_link_1" ><?php echo $options['hm_exhibition_before_link_1']; ?></textarea>
			<?php
		}
		public static function hm_exhibition_link_1_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_exhibition_link_1_text]" class="hm_exhibition_link_1_text" value="<?php echo $options['hm_exhibition_link_1_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_exhibition_link_1_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_exhibition_link_1_url]" class="hm_exhibition_link_1_url" value="<?php echo $options['hm_exhibition_link_1_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_exhibition_before_link_2_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_exhibition_before_link_2]" class="hm_exhibition_before_link_2" ><?php echo $options['hm_exhibition_before_link_2']; ?></textarea>
			<?php
		}
		public static function hm_exhibition_link_2_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_exhibition_link_2_text]" class="hm_exhibition_link_2_text" value="<?php echo $options['hm_exhibition_link_2_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_exhibition_link_2_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_exhibition_link_2_url]" class="hm_exhibition_link_2_url" value="<?php echo $options['hm_exhibition_link_2_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_exhibition_after_link_2_render(  ) { 
			$options = self::get_settings();
			?>
			<textarea rows="5" cols="60" name="hm_ve_settings[hm_exhibition_after_link_2]" class="hm_exhibition_after_link_2" ><?php echo $options['hm_exhibition_after_link_2']; ?></textarea>
			<?php
		}
		
		
		//از دست ندهید
		public static function hm_miss_link_1_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_miss_link_1_text]" class="hm_miss_link_1_text" value="<?php echo $options['hm_miss_link_1_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_miss_link_1_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_miss_link_1_url]" class="hm_miss_link_1_url" value="<?php echo $options['hm_miss_link_1_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_miss_link_2_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_miss_link_2_text]" class="hm_miss_link_2_text" value="<?php echo $options['hm_miss_link_2_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_miss_link_2_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_miss_link_2_url]" class="hm_miss_link_2_url" value="<?php echo $options['hm_miss_link_2_url']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_miss_link_3_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_miss_link_3_text]" class="hm_miss_link_3_text" value="<?php echo $options['hm_miss_link_3_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_miss_link_3_url_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_miss_link_3_url]" class="hm_miss_link_3_url" value="<?php echo $options['hm_miss_link_3_url']; ?>" style="width: 400px;" />
			<?php
		}
		//خرید خودروی کارشناسی شده
		public static function hm_car_link_start_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_car_link_start_text]" class="hm_car_link_start_text" value="<?php echo $options['hm_car_link_start_text']; ?>" style="width: 400px;" />
			<?php
		}
		public static function hm_car_link_end_text_render(  ) { 
			$options = self::get_settings();
			?>
			<input type="text" name="hm_ve_settings[hm_car_link_end_text]" class="hm_car_link_end_text" value="<?php echo $options['hm_car_link_end_text']; ?>" style="width: 400px;" />
			<?php
		}
		
		
		
		//plugin_dir_url( __FILE__ ) . 'assets/back.js'
		//توضیحات سکشن ها
		public static function hm_settings_section_callback(  ) { 
			echo __( 'تنظیمات پیشفرض شرت کات نصب اپ', 'hm-ve-shortcodes' );
			echo '<div><img class="demo_hm_shortcode" src="'.plugin_dir_url( __FILE__ ) . 'assets/demo/install_app_demo.png'.'" ></div>';
		}
		public static function hm_settings_section_callback_sell(  ) { 
			echo __( 'تنظیمات پیشفرض شرت کات فروش', 'hm-ve-shortcodes' );
			echo '<div><img class="demo_hm_shortcode" src="'.plugin_dir_url( __FILE__ ) . 'assets/demo/sell_demo.png'.'" ></div>';
		}
		public static function hm_settings_section_callback_buy(  ) { 
			echo __( 'تنظیمات پیشفرض شرت کات خرید', 'hm-ve-shortcodes' );
			echo '<div><img class="demo_hm_shortcode" src="'.plugin_dir_url( __FILE__ ) . 'assets/demo/buy_demo.png'.'" ></div>';
		}
		public static function hm_settings_section_callback_exhibition(  ) { 
			echo __( 'تنظیمات پیشفرض شرت کات نمایشگاه', 'hm-ve-shortcodes' );
			echo '<div><img class="demo_hm_shortcode" src="'.plugin_dir_url( __FILE__ ) . 'assets/demo/exhibition_demo.png'.'" ></div>';
		}
		public static function hm_settings_section_callback_miss(  ) { 
			echo __( 'تنظیمات پیشفرض شرت کات از دست ندهید', 'hm-ve-shortcodes' );
			echo '<div><img class="demo_hm_shortcode" src="'.plugin_dir_url( __FILE__ ) . 'assets/demo/miss_demo.png'.'" ></div>';
		}
		public static function hm_settings_section_callback_car_link(  ) { 
			echo __( 'تنظیمات پیشفرض شرت کات خرید خودروی کارشناسی شده', 'hm-ve-shortcodes' );
			//echo '<div><img class="demo_hm_shortcode" src="'.plugin_dir_url( __FILE__ ) . 'assets/demo/miss_demo.png'.'" ></div>';
		}
		public static function hm_visual_editor_shortcodes_options_page(  ) { 
				?>
				<form action='options.php' method='post'>
					<h2><?php _e( 'hm visual editor shortcodes',  'hm-ve-shortcodes' ); ?></h2>
					<?php
					settings_fields( 'hm_settings_register' );
					do_settings_sections( 'hm_settings_register' );
					submit_button();
					?>
				</form>
				<?php
		}
		public static function register_route(){
			
			// /wp-json/hmves/add_new_record
			register_rest_route( 'hmves', 'add_new_record', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'add_new_record_fun' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					return current_user_can( 'publish_posts' );
					//return true;
				}, 
			));
			// /wp-json/hmves/import_records
			register_rest_route( 'hmves', 'import_records', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'import_records_fun' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					return current_user_can( 'publish_posts' );
					//return true;
				}, 
			));
			// /wp-json/hmves/get_all_registered_recods_db
			register_rest_route( 'hmves', 'get_all_registered_recods_db', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_all_registered_recods_db_fun' ),
			));
			// /wp-json/hmves/update_selected_record
			register_rest_route( 'hmves', 'update_selected_record', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'update_selected_record_func' ),
			));
			// /wp-json/hmves/delete_selected_record
			register_rest_route( 'hmves', 'delete_selected_record', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'delete_selected_record_func' ),
			));
			// /wp-json/hmves/delete_all_existing_records
			register_rest_route( 'hmves', 'delete_all_existing_records', array(
				'methods' => 'POST',
				'callback' => array( __CLASS__, 'delete_all_existing_records_func' ),
				'permission_callback' => function() {
					return current_user_can( 'delete_posts' ); 
				}, 
			));
			
			
		}
		public static function add_new_record_fun() {
			if(isset($_POST['official_name']) and isset($_POST['api_request_type']) and $_POST['api_request_type'] == "add_new_record"){
				$post_array = array(
					'post_title'   => $_POST['official_name'] ,
					'post_content' => ' ' ,
					'post_status'  => 'publish',
					'post_type'	   => 'hmves_car_buy_url',
					'post_author'  => get_current_user_id(),
					'meta_input'   => array(
						'hmves_record_name' => $_POST['official_name'],
						'hmves_record_url' => $_POST['buy_url'], 
					),
				);
				$results = get_posts(array(
				   'post_type' => 'hmves_car_buy_url',
				   'meta_key'   => 'hmves_record_url',
				   'meta_value' => $_POST['buy_url'],
				));
				if(empty($results)){
					$insert_result = wp_insert_post( $post_array );
					if ( is_wp_error( $insert_result ) ) {
						//$error_string = $result->get_error_message();
						//echo '<div id="message" class="error"><p>' . $error_string . '</p></div>';
						$to_return =  "<span style='color:red;'>خطا ! رکورد مورد نظر ثبت نشد</span>";
					}else{
						$to_return =  "<span style='color:green;'>رکورد وارد شده ثبت شد</span>";
					}
				}else{
					$to_return =  "<span style='color:red;'>این رکورد قبلا ثبت شده</span>";
				}
			}else{
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		public static function import_records_fun() {
			if(isset($_POST['records_array']) and isset($_POST['api_request_type']) and $_POST['api_request_type'] == "import_records"){
				$to_return = '';
				$fail_words = "";
				foreach($_POST['records_array'] as $record_array){
					$post_array = array(
						'post_title'   => $record_array['record_name'] ,
						'post_content' => ' ' ,
						'post_status'  => 'publish',
						'post_type'	   => 'hmves_car_buy_url',
						'post_author'  => get_current_user_id(),
						'meta_input'   => array(
							'hmves_record_name' => $record_array['record_name'],
							'hmves_record_url' => $record_array['record_url'], 
						),
					);
					$results = get_posts(array(
					   'post_type' => 'hmves_car_buy_url',
					   'meta_key'   => 'hmves_record_url',
					   'meta_value' => $record_array['record_url'],
					));
					if(empty($results)){
						$insert_result = wp_insert_post( $post_array );
						if ( is_wp_error( $insert_result ) ) {
							//
						}else{
							
						}
					}else{
						$fail_words = $fail_words . " " . $record_array['record_name'] . " - ";
					}
					if($fail_words != ""){
						$to_return =  "<span style='color:red;'>رکوردهای رو برو ثبت نشدند ، چون تکراری بودند :</span>";
						$to_return =  $to_return . "<span style='color:orange;'>" . $fail_words . "</span>";
					}else{
						$to_return =  "<span style='color:green;'>تمام رکوردها با موفقیت در سامانه وارد شدند</span>";
					}
				}
			}else{
				$to_return = "param not sent properly";
			}
			
			
			return rest_ensure_response( $to_return );
		}
		public static function get_all_registered_recods_db_fun() {
			$results = get_posts(array(
			   'post_type' => 'hmves_car_buy_url',
			   'numberposts'=> '-1',
			));
			
			
			$data = array();
			$options = array();
			$files = array();
			
			if(!empty($results)){
				foreach($results as $index => $p_obj){
					$obj = new stdClass();
					$obj->id = $p_obj->ID;
					$obj->hmves_record_name = get_post_meta( $p_obj->ID, 'hmves_record_name', true );
					$obj->hmves_record_url = get_post_meta( $p_obj->ID, 'hmves_record_url', true );
					$obj->DT_RowId = 'row_'.$p_obj->ID;
					$data[] = $obj;
				}
			}
			
			$to_return = array('data' => $data,'options' => $options,'files' => $files);
			
			return rest_ensure_response( $to_return );
		}
		//https://www.coditty.com/code/wordpress-api-custom-route-access-post-parameters
		public static function update_selected_record_func() {
			if(isset($_POST['id']) and isset($_POST['editRowBtn']) and isset($_POST['hmves_record_name'])){
				$data = array();
				$id = $_POST['id'];
				
				update_post_meta( $id, 'hmves_record_name', $_POST['hmves_record_name'] );
				update_post_meta( $id, 'hmves_record_url', $_POST['hmves_record_url']);
				//
				$obj = new stdClass();
				$obj->id = $id;
				$obj->hmves_wp_post_id = $id;
				$obj->hmves_record_name = get_post_meta( $id, 'hmves_record_name', true );
				$obj->hmves_record_url = get_post_meta( $id, 'hmves_record_url', true );
				$obj->DT_RowId = 'row_'.$id;
				$to_return = $obj;
			}else{
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		public static function delete_selected_record_func() {
			$data = array();
			if(isset($_POST['id']) and isset($_POST['hmves_record_name'])){
				
				$id = $_POST['id'];
				wp_delete_post((int)$id);
				$to_return = $_POST;
				
			}else{
				//$to_return = $_POST;
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		//delete_all_existing_records_func
		public static function delete_all_existing_records_func() {
			$data = array();
			if(isset($_POST['api_request_type']) and isset($_POST['api_request_type']) =='delete_all_existing_records' ){
				foreach($_POST['existing_rows'] as $row){
					$post_id = $row['id'];
					wp_delete_post((int)$post_id );
					$to_return = $_POST;
				}
			}else{
				//$to_return = $_POST;
				$to_return = "param not sent properly";
			}
			return rest_ensure_response( $to_return );
		}
		public static function hm_visual_editor_shortcodes_car_urls_submenu(  ) { 
				?>
				<script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
				<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
				
				<script type="text/javascript" src="//cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js"></script>
				<link href="//cdn.datatables.net/1.10.20/css/jquery.dataTables.min.css" rel="stylesheet">
				
				<script type="text/javascript" src="//cdn.datatables.net/responsive/2.2.3/js/dataTables.responsive.min.js"></script>
				<link href="//cdn.datatables.net/responsive/2.2.3/css/responsive.dataTables.min.css" rel="stylesheet">
				
				<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/buttons.print.min.js"></script>
				<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/dataTables.buttons.min.js"></script>
				<link href="//cdn.datatables.net/buttons/1.6.0/css/buttons.dataTables.min.css" rel="stylesheet">

				<script type="text/javascript" language="javascript" src="//cdn.datatables.net/buttons/1.6.1/js/buttons.flash.min.js"></script>
				<script type="text/javascript" language="javascript" src="//cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
				<script type="text/javascript" language="javascript" src="//cdn.datatables.net/buttons/1.6.1/js/buttons.html5.min.js"></script>
				
				
				<script type="text/javascript" src="//cdn.datatables.net/select/1.3.1/js/dataTables.select.min.js"></script>
				<link href="//cdn.datatables.net/select/1.3.1/css/select.dataTables.min.css" rel="stylesheet">
				
				<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.15.6/jszip.js"></script>
				<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.15.6/xlsx.js"></script>
				
				<script type="text/javascript" src="<?php echo hmves_url.'dataTables.altEditor.free/dataTables.altEditor.free.js'; ?>"></script>
				<script type="text/javascript" src="<?php //echo hmves_url.'data-tables-editor/js/dataTables.editor.min.js'; ?>"></script>
				<link href="<?php echo hmves_url.'data-tables-editor/css/editor.dataTables.min.css'; ?>" rel="stylesheet">
				
				<script>
					<?php 
						$admin_ajax_url =  admin_url( 'admin-ajax.php' );
						echo "hmves_admin_ajax_url = '".$admin_ajax_url."';";
						echo "hmves_this_site_url  = '".get_site_url()."';";//http://www.example.com
						//ایجاد کوکی برای ویریفای شخص حاضر در جاوا اسکریپت
						$hmves_authentication = array('nonce' => wp_create_nonce('wp_rest'));
						?>var hmves_authentication = <?php echo json_encode($hmves_authentication) ?>;<?php
					?>
				</script>
				<script type="text/javascript" src="<?php echo hmves_url.'assets/sub_menu_1_back.js?v='.hm_visual_editor_shortcodes_version; ?>"></script>
				<link href="<?php echo hmves_url.'assets/sub_menu_1_back.css?v='.hm_visual_editor_shortcodes_version; ?>" rel="stylesheet">
				<script>
				jQuery(document).ready( function () {
					//hmves_get_from_api(); 
				} );
				</script>
				<div id="hmves_main_wrapper">
				<div id="hmves_main_inner">
					<form id="hmves_add_new_form" class="hmves_add_new_form_class" action="">
						
						<div class="container hmves_select_wrapper">
							<div class="row">
								<div class="col-sm-12"> 
									<div class="hmves_title">
									ثبت خودرو
									<div id="hmves_loading_ajax_top" style="position:absolute;"class="lds-dual-ring hmves_loading"></div>
									</div>
									<div class="hmves_disc"></div>
								</div>
							</div>
						  <div class="row ">
							<div class="col-sm-2">
							  <div class="hmves_column_title">نام خودرو</div>
							  <input id="hmves_official_name" type="text" class="form-control" >
							</div>
							<div class="col-sm-2">
							  <div class="hmves_column_title">URL</div>
							  <input id="hmves_buy_url" type="text" class="form-control" >
							</div>
							<div class="col-sm-2 ">
								<div class="hmves_column_title"    style="visibility: hidden;">.</div>
								<button type="button" id="hmves_add_new_record_to_db" class="btn btn-default" onclick="hmves_add_new_record();">افزودن</button>
							</div>
							<div class="col-sm-2">
							  <div class="hmves_column_title">انتخاب فایل</div>
							  <input id="hmves_import_records" type="file" class="form-control" accept=".xls,.xlsx">
							</div>
							<div class="col-sm-2 "> 
								<div class="hmves_column_title"    style="visibility: hidden;">.</div>
								<button type="button" id="hmves_import_file_submit" class="btn btn-default" onclick="hmves_import_file()">ایمپورت</button>
							</div>
						  </div>
						</div>

						<div id="hmves_ajax_response_target" style="display:none;">
							
						</div>
					</form>
					<div id="hmves_loading_ajax_result_table" style="position:absolute;display:none;right:8px;margin-top:22px;" class="lds-dual-ring "></div>
					<div id="hmves_result_section"  style="display:none;">
						<table id="hmves_result_car_table" class="display cell-border hover " style="">
							<thead>
								<tr>
									<th>آیدی</th>
									<th>نام خودرو</th>
									<th>url</th>
								</tr>
							</thead>
							<tfoot>
							</tfoot>
						</table>
					</div>
		
				</div>	
			</div>	
			<?php
		}
		
		public static function echo_shortcode($atts) { 
			$settings =  self::get_settings();
			extract( shortcode_atts( array(
				'type' => '',
				'text1' => '',
				'url1' => '',
				'text2' => '',
				'url2' => '',
				'text3' => '',
				'url3' => '',
				'record_id' => '',
				'name' => '',
			), $atts) );
			ob_start(); ?>
			<script type="text/javascript" src="<?php echo hmves_url.'assets/front.js?v='.hm_visual_editor_shortcodes_version;  ?>"></script>
			<link href="<?php echo hmves_url.'assets/front.css?v='.hm_visual_editor_shortcodes_version; ?>"" rel="stylesheet">
			<script>
			jQuery(document).ready( function () {
				
			} );
			</script>
			<?php if($type=='miss'){ ?>
			
				<div id="hm_miss_wrapper">
					<div class="hm_miss_title" >مطالعه مقالات زیر را از دست ندهید</div>
					<ul class="hm_miss_ul">
						<?php if(!empty($text1)){ ?><li><a href="<?php echo $url1; ?>"  rel="nofollow" ><?php echo $text1; ?></a></li><?php } ?>
						<?php if(!empty($text2)){ ?><li><a href="<?php echo $url2; ?>"  rel="nofollow" ><?php echo $text2; ?></a></li><?php } ?>
						<?php if(!empty($text3)){ ?><li><a href="<?php echo $url3; ?>"  rel="nofollow" ><?php echo $text3; ?></a></li><?php } ?>
					</ul>
				</div>
				
			<?php }elseif($type=='install_app'){ ?>
			
				<?php $hm_install_app_text =  $settings['hm_install_app_text']; ?>
				<?php $hm_install_app_url =  $settings['hm_install_app_url']; ?>
				
				<div id="hm_install_app_wrapper" onclick="window.open('<?php echo  $settings['hm_install_app_url']; ?>','_blank')" style="background-image:url(<?php echo hmves_url.'assets/dn_app_back.png'; ?>)">
						<?php if(!empty($hm_install_app_text)){ ?><span class="hm_install_app_url" ><?php echo $hm_install_app_text; ?></a><?php } ?>
				</div>
				
				<!--i class="fa-check-square-o font-awesome fa"></i-->
			<?php }elseif($type=='buy'){ ?>
			
					<?php $hm_buy_before_link_1 =  $settings['hm_buy_before_link_1']; ?>
					<?php $hm_buy_link_1_text =  $settings['hm_buy_link_1_text']; ?>
					<?php $hm_buy_link_1_url =  $settings['hm_buy_link_1_url']; ?>
					<?php $hm_buy_before_link_2 = $settings['hm_buy_before_link_2']; ?>
					<?php $hm_buy_link_2_text =  $settings['hm_buy_link_2_text']; ?>
					<?php $hm_buy_link_2_url =  $settings['hm_buy_link_2_url']; ?>
					<?php $hm_buy_after_link_2 =  $settings['hm_buy_after_link_2']; ?>
 
					<div id="hm_buy_wrapper">
						<p class="hm_buy_wrapper_p">
							<?php if(!empty($hm_buy_before_link_1)){ echo $hm_buy_before_link_1; } ?>
							<?php if(!empty($hm_buy_link_1_text)){ ?><a class="hm_buy_link_1_text" href="<?php echo $hm_buy_link_1_url; ?>"  rel="nofollow" ><?php echo $hm_buy_link_1_text; ?></a><?php } ?>
							<?php if(!empty($hm_buy_before_link_2)){ echo $hm_buy_before_link_2; } ?>
							<?php if(!empty($hm_buy_link_2_text)){ ?><a class="hm_buy_link_2_text" href="<?php echo $hm_buy_link_2_url; ?>"  rel="nofollow" ><?php echo $hm_buy_link_2_text; ?></a><?php } ?>
							<?php if(!empty($hm_buy_after_link_2)){ echo $hm_buy_after_link_2; } ?>
						</p>
					</div>
					
			<?php } elseif($type=='sell'){ ?>
			
					<?php $hm_sell_before =  $settings['hm_sell_before']; ?>
					<?php $hm_sell_link_text =  $settings['hm_sell_link_text']; ?>
					<?php $hm_sell_link_url =  $settings['hm_sell_link_url']; ?>
					<?php $hm_sell_after =  $settings['hm_sell_after']; ?>
					
					<div id="hm_sell_wrapper">
						<p class="hm_sell_wrapper_p">
							<?php if(!empty($hm_sell_before)){ echo $hm_sell_before; } ?>
							<?php if(!empty($hm_sell_link_text)){ ?><a class="hm_sell_link_text" href="<?php echo $hm_sell_link_url; ?>"  rel="nofollow" ><?php echo $hm_sell_link_text; ?></a><?php } ?>
							<?php if(!empty($hm_sell_after)){ echo $hm_sell_after; } ?>
						</p>
					</div>
					
			<?php }elseif($type=='exhibition'){   ?>
					<?php $hm_exhibition_before_link_1 = $settings['hm_exhibition_before_link_1']; ?>
					<?php $hm_exhibition_link_1_text =  $settings['hm_exhibition_link_1_text']; ?>
					<?php $hm_exhibition_link_1_url =  $settings['hm_exhibition_link_1_url']; ?>
					<?php $hm_exhibition_before_link_2 =  $settings['hm_exhibition_before_link_2']; ?>
					<?php $hm_exhibition_link_2_text = $settings['hm_exhibition_link_2_text']; ?>
					<?php $hm_exhibition_link_2_url =  $settings['hm_exhibition_link_2_url']; ?>
					<?php $hm_exhibition_after_link_2 =  $settings['hm_exhibition_after_link_2']; ?>
					
					<div id="hm_exhibition_wrapper">
						<p class="hm_exhibition_wrapper_p">
							<?php if(!empty($hm_exhibition_before_link_1)){ echo $hm_exhibition_before_link_1; } ?>
							<?php if(!empty($hm_exhibition_link_1_text)){ ?><a class="hm_exhibition_link_1_text" href="<?php echo $hm_exhibition_link_1_url; ?>"  rel="nofollow" ><?php echo $hm_exhibition_link_1_text; ?></a><?php } ?>
							<?php if(!empty($hm_exhibition_before_link_2)){ echo $hm_exhibition_before_link_2; } ?>
							<?php if(!empty($hm_exhibition_link_2_text)){ ?><a class="hm_exhibition_link_2_text" href="<?php echo $hm_exhibition_link_2_url; ?>"  rel="nofollow" ><?php echo $hm_exhibition_link_2_text; ?></a><?php } ?>
							<?php if(!empty($hm_exhibition_after_link_2)){ echo $hm_exhibition_after_link_2; } ?>
						</p>
					</div>
					
			<?php }elseif($type=='car_link'){   ?>
					<?php  if (!empty($record_id)){ ?>
					<?php 
						   $record_name = get_post_meta( (int)$record_id, 'hmves_record_name', true );
						   $record_url = get_post_meta( (int)$record_id, 'hmves_record_url', true );
						   //ضروری نیست 
							if (!strpos($record_url, 'cars-for-sale/search?') !== false) {
							    $record_url = str_replace("cars-for-sale/search?", "cars-for-sale/search/?",  $record_url);
							} 


					?>
					
					<?php $hm_car_link_start_text = $settings['hm_car_link_start_text']; ?>
					<?php $hm_car_link_end_text =  $settings['hm_car_link_end_text']; ?>
					<div id="hm_car_link_wrapper">
						<p class="hm_car_link_wrapper_p">
							<?php if(!empty($hm_car_link_start_text)){ echo $hm_car_link_start_text; } ?>
							<?php if(!empty($name)){ ?><span class="hm_car_name_cclass"  ><?php echo $name; ?></span><?php } ?>
							<?php if(!empty($hm_car_link_end_text)){ echo $hm_car_link_end_text; } ?>
						</p>
						<?php if(!empty($record_url)){ ?><a class="hm_car_link_text_a" href="<?php echo $record_url; ?>"  rel="nofollow" target="_blank" ><!--i class="fa-check-square-o font-awesome fa"></i--><?php echo 'خرید '. $record_name; ?></a><?php } ?>
					</div>
					<?php  } ?>
			<?php } ?>
			<?php
			$out = ob_get_clean();
			return $out;
		}
	
		private static function get_settings() {
			self::$settings = get_option( 'hm_ve_settings' );
			return self::$settings;
		}
		
		public static function enqueue_backend() {
			wp_enqueue_script("jquery");
			wp_enqueue_style('hm_back_css', plugins_url('assets/back.css',__FILE__ ),'',hm_visual_editor_shortcodes_version);
			//wp_enqueue_script('back_js', plugins_url('assets/back.js',__FILE__ ),array('jquery'),hm_visual_editor_shortcodes_version);
		}
		public static function enqueue_front(){
			
			wp_enqueue_script("jquery");
			//wp_enqueue_script('sr_front_js', plugins_url('assets/front.js',__FILE__ ),array('jquery'),hm_visual_editor_shortcodes_version);
			//$data = array('name_1'   => admin_url( 'admin-ajax.php' ),'a_value' => '10');
			//wp_localize_script('sr_front_js', 'pefix_handel', $data);
			//wp_enqueue_style('sr_front_css', plugins_url('assets/front.css',__FILE__ ),'',hm_visual_editor_shortcodes_version);
			//wp_enqueue_style('sr_front_csr_rtl', plugins_url('assets/front_rtl.css',__FILE__ ),'',hm_visual_editor_shortcodes_version);
		}
		public static function add_settings_link( $links, $file ) {
			if ( current_user_can( 'manage_options' ) ) {
				$url = admin_url( 'admin.php?page=hm_visual_editor_shortcodes' );
				$links = (array) $links;
				$links[] = sprintf( '<a href="%s">%s</a>', $url, __( 'Settings', 'hm-ve-shortcodes' ) );
			}
			return $links;
		}
		public static function activate() {
			
			$settings = array(//
				'hm_install_app_text' => ' با کلیک روی این دکمه و نصب اپلیکیشن همراه مکانیک دیگه همیشه از قیمت خودروت آگاهی و کسی نمیتونه ازت کلاهبرداری کنه.' ,
				'hm_install_app_url' =>'https://www.hamrah-mechanic.com/hmechanic.apk' ,
				'hm_sell_before' => 'خودرو خودت رو بدون دغدغه و چونه زدن با دلال به مشتری واقعی در طرح فروش سفارشی همراه مکانیک بفروش ' ,
				'hm_sell_link_text' => 'اینجا',
				'hm_sell_link_url' => 'https://www.hamrah-mechanic.com/car-sell/' ,
				'hm_sell_after' => 'کلیک کن ',
				'hm_buy_before_link_1' => 'اگر قصد خرید خودرو داری ولی وقت کافی برای پیدا کردن خودرو مناسب اونم با گارانتی رو نداری کافیه' ,
				'hm_buy_link_1_text' => ' اینجا' ,
				'hm_buy_link_1_url' => 'https://www.hamrah-mechanic.com/car-buy/' ,
				'hm_buy_before_link_2' => 'کلیک کنید و فرم ثبت' ,
				'hm_buy_link_2_text' => 'خرید سفارشی' ,
				'hm_buy_link_2_url' => 'https://www.hamrah-mechanic.com/car-buy/' ,
				'hm_buy_after_link_2' => 'رو پر کنید' ,
				'hm_exhibition_before_link_1' => 'تابحال' ,
				'hm_exhibition_link_1_text' => 'خرید خودرو دست دوم' ,
				'hm_exhibition_link_1_url' => 'https://www.hamrah-mechanic.com/cars-for-sale/' ,
				'hm_exhibition_before_link_2' => 'با گارانتی اونم از بزرگترین نمایشگاه آنلاین خودرو در کشور رو تجربه کردیبرای کسب تجربه بی نظیر' ,
				'hm_exhibition_link_2_text' => 'اینجا' ,
				'hm_exhibition_link_2_url' => 'https://www.hamrah-mechanic.com/cars-for-sale/' ,
				'hm_exhibition_after_link_2' => 'کلیک کن' ,
				'hm_miss_link_1_text' => 'تعویض پلاک خودرو' ,
				'hm_miss_link_1_url' => 'https://www.hamrah-mechanic.com/mag/process-of-license-plate-replacement/' ,
				'hm_miss_link_2_text' => 'راهنمای خرید دست دوم' ,
				'hm_miss_link_2_url' => 'https://www.hamrah-mechanic.com/mag/guidance-buying-used-cars-technical-tips/' ,
				'hm_miss_link_3_text' => '' ,
				'hm_miss_link_3_url' => '' ,
				'hm_car_link_start_text' => 'دلت می خواد' ,
				'hm_car_link_end_text' => 'رو کارشناسی شده و با ضمانت بخری ، روی لینک زیر کلیک کن' ,
			);
			if (!get_option( 'hm_ve_settings' )){
				add_option( 'hm_ve_settings', $settings );
			}
			
		}
		public static function deactivat() {
			//delete_option( 'hm_ve_settings' );
		}
		public static function uninstall() {
			//delete_option( 'hm_ve_settings' );
		}
		
	}
	add_action( 'plugins_loaded', array( 'hm_visual_editor_shortcodes', 'init_actions' ) );
	register_activation_hook( __FILE__, array( 'hm_visual_editor_shortcodes', 'activate' ) );
	register_deactivation_hook(__FILE__, array( 'hm_visual_editor_shortcodes', 'deactivat'));

}

